diff --git a/gcc/tree-eh.c b/gcc/tree-eh.c
index 2eb3097..10bf550 100644
--- a/gcc/tree-eh.c
+++ b/gcc/tree-eh.c
@@ -2134,25 +2134,35 @@ lower_eh_constructs (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_lower_eh =
+class pass_lower_eh : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "eh",					/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  lower_eh_constructs,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_EH,				/* tv_id */
-  PROP_gimple_lcf,			/* properties_required */
-  PROP_gimple_leh,			/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+public:
+  pass_lower_eh(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "eh",
+		      OPTGROUP_NONE,
+		      TV_TREE_EH,
+		      pass_properties(required(PROP_gimple_lcf),
+				      provided(PROP_gimple_leh),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return lower_eh_constructs (); }
+
+}; // class pass_lower_eh
+
+gimple_opt_pass *
+make_pass_lower_eh (context &ctxt)
+{
+  return new pass_lower_eh (ctxt);
+}
 
 /* Create the multiple edges from an EH_DISPATCH statement to all of
    the possible handlers for its EH region.  Return true if there's
@@ -2994,25 +3004,35 @@ gate_refactor_eh (void)
   return flag_exceptions != 0;
 }
 
-struct gimple_opt_pass pass_refactor_eh =
+class pass_refactor_eh : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ehopt",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_refactor_eh,			/* gate */
-  refactor_eh,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_EH,				/* tv_id */
-  PROP_gimple_lcf,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0             			/* todo_flags_finish */
- }
-};
+public:
+  pass_refactor_eh(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ehopt",
+		      OPTGROUP_NONE,
+		      TV_TREE_EH,
+		      pass_properties(required(PROP_gimple_lcf),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_refactor_eh (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return refactor_eh (); }
+
+}; // class pass_refactor_eh
+
+gimple_opt_pass *
+make_pass_refactor_eh (context &ctxt)
+{
+  return new pass_refactor_eh (ctxt);
+}
 
 /* At the end of gimple optimization, we can lower RESX.  */
 
@@ -3203,25 +3223,35 @@ gate_lower_resx (void)
   return flag_exceptions != 0;
 }
 
-struct gimple_opt_pass pass_lower_resx =
+class pass_lower_resx : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "resx",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_lower_resx,			/* gate */
-  execute_lower_resx,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_EH,				/* tv_id */
-  PROP_gimple_lcf,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_flow	                /* todo_flags_finish */
- }
-};
+public:
+  pass_lower_resx(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "resx",
+		      OPTGROUP_NONE,
+		      TV_TREE_EH,
+		      pass_properties(required(PROP_gimple_lcf),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_lower_resx (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_lower_resx (); }
+
+}; // class pass_lower_resx
+
+gimple_opt_pass *
+make_pass_lower_resx (context &ctxt)
+{
+  return new pass_lower_resx (ctxt);
+}
 
 /* Try to optimize var = {v} {CLOBBER} stmts followed just by
    external throw.  */
@@ -3549,25 +3579,35 @@ gate_lower_eh_dispatch (void)
   return cfun->eh->region_tree != NULL;
 }
 
-struct gimple_opt_pass pass_lower_eh_dispatch =
+class pass_lower_eh_dispatch : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ehdisp",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_lower_eh_dispatch,		/* gate */
-  execute_lower_eh_dispatch,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_EH,				/* tv_id */
-  PROP_gimple_lcf,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_flow	                /* todo_flags_finish */
- }
-};
+public:
+  pass_lower_eh_dispatch(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ehdisp",
+		      OPTGROUP_NONE,
+		      TV_TREE_EH,
+		      pass_properties(required(PROP_gimple_lcf),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_lower_eh_dispatch (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_lower_eh_dispatch (); }
+
+}; // class pass_lower_eh_dispatch
+
+gimple_opt_pass *
+make_pass_lower_eh_dispatch (context &ctxt)
+{
+  return new pass_lower_eh_dispatch (ctxt);
+}
 
 /* Walk statements, see what regions and, optionally, landing pads
    are really referenced.
@@ -4401,24 +4441,35 @@ gate_cleanup_eh (void)
   return cfun->eh != NULL && cfun->eh->region_tree != NULL;
 }
 
-struct gimple_opt_pass pass_cleanup_eh = {
-  {
-   GIMPLE_PASS,
-   "ehcleanup",			/* name */
-   OPTGROUP_NONE,               /* optinfo_flags */
-   gate_cleanup_eh,		/* gate */
-   execute_cleanup_eh,		/* execute */
-   NULL,			/* sub */
-   NULL,			/* next */
-   0,				/* static_pass_number */
-   TV_TREE_EH,			/* tv_id */
-   PROP_gimple_lcf,		/* properties_required */
-   0,				/* properties_provided */
-   0,				/* properties_destroyed */
-   0,				/* todo_flags_start */
-   0             		/* todo_flags_finish */
-   }
-};
+class pass_cleanup_eh : public gimple_opt_pass
+{
+public:
+  pass_cleanup_eh(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ehcleanup",
+		      OPTGROUP_NONE,
+		      TV_TREE_EH,
+		      pass_properties(required(PROP_gimple_lcf),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_cleanup_eh (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_cleanup_eh (); }
+
+}; // class pass_cleanup_eh
+
+gimple_opt_pass *
+make_pass_cleanup_eh (context &ctxt)
+{
+  return new pass_cleanup_eh (ctxt);
+}
 
 /* Verify that BB containing STMT as the last statement, has precisely the
    edge that make_eh_edges would create.  */
diff --git a/gcc/tree-emutls.c b/gcc/tree-emutls.c
index fc75b31..21c450c 100644
--- a/gcc/tree-emutls.c
+++ b/gcc/tree-emutls.c
@@ -809,22 +809,32 @@ gate_emutls (void)
   return !targetm.have_tls;
 }
 
-struct simple_ipa_opt_pass pass_ipa_lower_emutls =
+class pass_ipa_lower_emutls : public simple_ipa_opt_pass
 {
- {
-  SIMPLE_IPA_PASS,
-  "emutls",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_emutls,				/* gate */
-  ipa_lower_emutls,			/* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_IPA_OPT,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0,					/* todo_flags_finish */
- }
-};
+public:
+  pass_ipa_lower_emutls(context &ctxt)
+    : simple_ipa_opt_pass(ctxt,
+			  "emutls",
+			  OPTGROUP_NONE,
+			  TV_IPA_OPT,
+			  pass_properties(required(PROP_cfg | PROP_ssa),
+					  provided(0),
+					  destroyed(0)),
+			  pass_todo_flags(start(0),
+					  finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_emutls (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return ipa_lower_emutls (); }
+
+}; // class pass_ipa_lower_emutls
+
+simple_ipa_opt_pass *
+make_pass_ipa_lower_emutls (context &ctxt)
+{
+  return new pass_ipa_lower_emutls (ctxt);
+}
diff --git a/gcc/tree-if-conv.c b/gcc/tree-if-conv.c
index 95d0394..60f39f9 100644
--- a/gcc/tree-if-conv.c
+++ b/gcc/tree-if-conv.c
@@ -1853,23 +1853,32 @@ gate_tree_if_conversion (void)
 	  || flag_tree_loop_if_convert_stores == 1);
 }
 
-struct gimple_opt_pass pass_if_conversion =
+class pass_if_conversion : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ifcvt",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_tree_if_conversion,		/* gate */
-  main_tree_if_conversion,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_stmts | TODO_verify_flow
-                                        /* todo_flags_finish */
- }
-};
+public:
+  pass_if_conversion(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ifcvt",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_stmts | TODO_verify_flow)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_if_conversion (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return main_tree_if_conversion (); }
+
+}; // class pass_if_conversion
+
+gimple_opt_pass *
+make_pass_if_conversion (context &ctxt)
+{
+  return new pass_if_conversion (ctxt);
+}
diff --git a/gcc/tree-into-ssa.c b/gcc/tree-into-ssa.c
index 65c15da..9bca54a 100644
--- a/gcc/tree-into-ssa.c
+++ b/gcc/tree-into-ssa.c
@@ -2408,26 +2408,35 @@ rewrite_into_ssa (void)
 }
 
 
-struct gimple_opt_pass pass_build_ssa =
-{
- {
-  GIMPLE_PASS,
-  "ssa",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  rewrite_into_ssa,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_SSA_OTHER,			/* tv_id */
-  PROP_cfg,				/* properties_required */
-  PROP_ssa,				/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa
-    | TODO_remove_unused_locals		/* todo_flags_finish */
- }
-};
+class pass_build_ssa : public gimple_opt_pass
+{
+public:
+  pass_build_ssa(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ssa",
+		      OPTGROUP_NONE,
+		      TV_TREE_SSA_OTHER,
+		      pass_properties(required(PROP_cfg),
+				      provided(PROP_ssa),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa | TODO_remove_unused_locals)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return rewrite_into_ssa (); }
+
+}; // class pass_build_ssa
+
+gimple_opt_pass *
+make_pass_build_ssa (context &ctxt)
+{
+  return new pass_build_ssa (ctxt);
+}
 
 
 /* Mark the definition of VAR at STMT and BB as interesting for the
diff --git a/gcc/tree-loop-distribution.c b/gcc/tree-loop-distribution.c
index 5c2c7db..bcfce6d 100644
--- a/gcc/tree-loop-distribution.c
+++ b/gcc/tree-loop-distribution.c
@@ -1589,22 +1589,32 @@ gate_tree_loop_distribution (void)
     || flag_tree_loop_distribute_patterns;
 }
 
-struct gimple_opt_pass pass_loop_distribution =
+class pass_loop_distribution : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "ldist",			/* name */
-  OPTGROUP_LOOP,                /* optinfo_flags */
-  gate_tree_loop_distribution,  /* gate */
-  tree_loop_distribution,       /* execute */
-  NULL,				/* sub */
-  NULL,				/* next */
-  0,				/* static_pass_number */
-  TV_TREE_LOOP_DISTRIBUTION,    /* tv_id */
-  PROP_cfg | PROP_ssa,		/* properties_required */
-  0,				/* properties_provided */
-  0,				/* properties_destroyed */
-  0,				/* todo_flags_start */
-  TODO_verify_ssa               /* todo_flags_finish */
- }
-};
+public:
+  pass_loop_distribution(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "ldist",
+		      OPTGROUP_LOOP,
+		      TV_TREE_LOOP_DISTRIBUTION,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_tree_loop_distribution (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_loop_distribution (); }
+
+}; // class pass_loop_distribution
+
+gimple_opt_pass *
+make_pass_loop_distribution (context &ctxt)
+{
+  return new pass_loop_distribution (ctxt);
+}
diff --git a/gcc/tree-mudflap.c b/gcc/tree-mudflap.c
index b250bfe..3a38866 100644
--- a/gcc/tree-mudflap.c
+++ b/gcc/tree-mudflap.c
@@ -1378,45 +1378,66 @@ gate_mudflap (void)
   return flag_mudflap != 0;
 }
 
-struct gimple_opt_pass pass_mudflap_1 =
+class pass_mudflap_1 : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "mudflap1",                           /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_mudflap,                         /* gate */
-  execute_mudflap_function_decls,       /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  PROP_gimple_any,                      /* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_mudflap_1(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "mudflap1",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_gimple_any),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_mudflap (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_mudflap_function_decls ();
+  }
+
+}; // class pass_mudflap_1
 
-struct gimple_opt_pass pass_mudflap_2 =
+gimple_opt_pass *
+make_pass_mudflap_1 (context &ctxt)
 {
- {
-  GIMPLE_PASS,
-  "mudflap2",                           /* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_mudflap,                         /* gate */
-  execute_mudflap_function_ops,         /* execute */
-  NULL,                                 /* sub */
-  NULL,                                 /* next */
-  0,                                    /* static_pass_number */
-  TV_NONE,                              /* tv_id */
-  PROP_ssa | PROP_cfg | PROP_gimple_leh,/* properties_required */
-  0,                                    /* properties_provided */
-  0,                                    /* properties_destroyed */
-  0,                                    /* todo_flags_start */
-  TODO_verify_flow | TODO_verify_stmts
-  | TODO_update_ssa                     /* todo_flags_finish */
- }
-};
+  return new pass_mudflap_1 (ctxt);
+}
+
+class pass_mudflap_2 : public gimple_opt_pass
+{
+public:
+  pass_mudflap_2(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "mudflap2",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa | PROP_cfg | PROP_gimple_leh),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_flow | TODO_verify_stmts | TODO_update_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_mudflap (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_mudflap_function_ops (); }
+
+}; // class pass_mudflap_2
+
+gimple_opt_pass *
+make_pass_mudflap_2 (context &ctxt)
+{
+  return new pass_mudflap_2 (ctxt);
+}
 
 #include "gt-tree-mudflap.h"
diff --git a/gcc/tree-nomudflap.c b/gcc/tree-nomudflap.c
index 657c82d..fef09d0 100644
--- a/gcc/tree-nomudflap.c
+++ b/gcc/tree-nomudflap.c
@@ -85,45 +85,65 @@ gate_mudflap (void)
   return flag_mudflap != 0;
 }
 
-struct gimple_opt_pass pass_mudflap_1 =
+class pass_mudflap_1 : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "mudflap1",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_mudflap,                         /* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_mudflap_1(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "mudflap1",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_mudflap (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_mudflap_1
+
+gimple_opt_pass *
+make_pass_mudflap_1 (context &ctxt)
+{
+  return new pass_mudflap_1 (ctxt);
+}
 
-struct gimple_opt_pass pass_mudflap_2 =
+class pass_mudflap_2 : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "mudflap2",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_mudflap,                         /* gate */
-  NULL,					/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  0,					/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0                                     /* todo_flags_finish */
- }
-};
+public:
+  pass_mudflap_2(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "mudflap2",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(0),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_mudflap (); }
+
+  bool has_execute () { return false; }
+  unsigned int impl_execute () { return 0; }
+
+}; // class pass_mudflap_2
+
+gimple_opt_pass *
+make_pass_mudflap_2 (context &ctxt)
+{
+  return new pass_mudflap_2 (ctxt);
+}
 
 /* Instead of:
 #include "gt-tree-mudflap.h"
diff --git a/gcc/tree-nrv.c b/gcc/tree-nrv.c
index 51bc7cd..de9b3de 100644
--- a/gcc/tree-nrv.c
+++ b/gcc/tree-nrv.c
@@ -269,25 +269,35 @@ gate_pass_return_slot (void)
   return optimize > 0;
 }
 
-struct gimple_opt_pass pass_nrv =
+class pass_nrv : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "nrv",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  gate_pass_return_slot,		/* gate */
-  tree_nrv,				/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_NRV,				/* tv_id */
-  PROP_ssa | PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_nrv(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "nrv",
+		      OPTGROUP_NONE,
+		      TV_TREE_NRV,
+		      pass_properties(required(PROP_ssa | PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return true; }
+  bool gate () { return gate_pass_return_slot (); }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return tree_nrv (); }
+
+}; // class pass_nrv
+
+gimple_opt_pass *
+make_pass_nrv (context &ctxt)
+{
+  return new pass_nrv (ctxt);
+}
 
 /* Determine (pessimistically) whether DEST is available for NRV
    optimization, where DEST is expected to be the LHS of a modify
@@ -355,22 +365,32 @@ execute_return_slot_opt (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_return_slot =
+class pass_return_slot : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "retslot",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_return_slot_opt,		/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_ssa,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_return_slot(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "retslot",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_return_slot_opt (); }
+
+}; // class pass_return_slot
+
+gimple_opt_pass *
+make_pass_return_slot (context &ctxt)
+{
+  return new pass_return_slot (ctxt);
+}
diff --git a/gcc/tree-object-size.c b/gcc/tree-object-size.c
index 2b8311a..af54ca6 100644
--- a/gcc/tree-object-size.c
+++ b/gcc/tree-object-size.c
@@ -1262,22 +1262,32 @@ compute_object_sizes (void)
   return 0;
 }
 
-struct gimple_opt_pass pass_object_sizes =
+class pass_object_sizes : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "objsz",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  compute_object_sizes,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg | PROP_ssa,			/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_verify_ssa	                /* todo_flags_finish */
- }
-};
+public:
+  pass_object_sizes(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "objsz",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg | PROP_ssa),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_verify_ssa)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return compute_object_sizes (); }
+
+}; // class pass_object_sizes
+
+gimple_opt_pass *
+make_pass_object_sizes (context &ctxt)
+{
+  return new pass_object_sizes (ctxt);
+}
diff --git a/gcc/tree-optimize.c b/gcc/tree-optimize.c
index a72369e..da3d467 100644
--- a/gcc/tree-optimize.c
+++ b/gcc/tree-optimize.c
@@ -88,25 +88,37 @@ execute_cleanup_cfg_post_optimizing (void)
   return todo;
 }
 
-struct gimple_opt_pass pass_cleanup_cfg_post_optimizing =
+class pass_cleanup_cfg_post_optimizing : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "optimized",				/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_cleanup_cfg_post_optimizing,	/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_TREE_CLEANUP_CFG,			/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  TODO_remove_unused_locals             /* todo_flags_finish */
- }
-};
+public:
+  pass_cleanup_cfg_post_optimizing(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "optimized",
+		      OPTGROUP_NONE,
+		      TV_TREE_CLEANUP_CFG,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(TODO_remove_unused_locals)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () {
+    return execute_cleanup_cfg_post_optimizing ();
+  }
+
+}; // class pass_cleanup_cfg_post_optimizing
+
+gimple_opt_pass *
+make_pass_cleanup_cfg_post_optimizing (context &ctxt)
+{
+  return new pass_cleanup_cfg_post_optimizing (ctxt);
+}
 
 /* IPA passes, compilation of earlier functions or inlining
    might have changed some properties, such as marked functions nothrow,
@@ -207,22 +219,32 @@ execute_fixup_cfg (void)
   return todo;
 }
 
-struct gimple_opt_pass pass_fixup_cfg =
+class pass_fixup_cfg : public gimple_opt_pass
 {
- {
-  GIMPLE_PASS,
-  "*free_cfg_annotations",		/* name */
-  OPTGROUP_NONE,                        /* optinfo_flags */
-  NULL,					/* gate */
-  execute_fixup_cfg,			/* execute */
-  NULL,					/* sub */
-  NULL,					/* next */
-  0,					/* static_pass_number */
-  TV_NONE,				/* tv_id */
-  PROP_cfg,				/* properties_required */
-  0,					/* properties_provided */
-  0,					/* properties_destroyed */
-  0,					/* todo_flags_start */
-  0					/* todo_flags_finish */
- }
-};
+public:
+  pass_fixup_cfg(context &ctxt)
+    : gimple_opt_pass(ctxt,
+		      "*free_cfg_annotations",
+		      OPTGROUP_NONE,
+		      TV_NONE,
+		      pass_properties(required(PROP_cfg),
+				      provided(0),
+				      destroyed(0)),
+		      pass_todo_flags(start(0),
+				      finish(0)))
+  {}
+
+  /* opt_pass methods: */
+  bool has_gate () { return false; }
+  bool gate () { return true; }
+
+  bool has_execute () { return true; }
+  unsigned int impl_execute () { return execute_fixup_cfg (); }
+
+}; // class pass_fixup_cfg
+
+gimple_opt_pass *
+make_pass_fixup_cfg (context &ctxt)
+{
+  return new pass_fixup_cfg (ctxt);
+}
